import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class parade_ip {
    FastScanner in;
    PrintWriter out;
    final String TASK_NAME = "parade";

    public void solve() throws IOException {
        int n = in.nextInt(), m = in.nextInt();
        int mx = 0;
        for (int i = 0; i < m; ++i) {
            int l = in.nextInt();
            int r = in.nextInt();
            mx = Math.max(mx, r - l + 1);
        }
        out.println(mx);
        for (int i = 0; i < n; ++i)
            if (i + 1 == n)
                out.println(i % mx + 1);
            else
                out.print((i % mx + 1) + " ");
    }

    public void run() {
        try {
            in = new FastScanner(new File(TASK_NAME + ".in"));
            out = new PrintWriter(new File(TASK_NAME + ".out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new parade_ip().run();
    }
}
